using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;

using Microsoft.UI.Xaml;

namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public sealed partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// ҽ  Ʈ
        /// </summary>
        private List<Recipe> sourceRecipeList;

        /// <summary>
        ///   Ƽ
        /// </summary>
        private RecipeList filteredRecipeList = new RecipeList(null);

        /// <summary>
        ///   
        /// </summary>
        private bool isSortDescending = false;

        /// <summary>
        ///  Ʈ
        /// </summary>
        private List<string> colorList = new List<string>()
        {
            "Blue",
            "BlueViolet",
            "Crimson",
            "DarkCyan",
            "DarkGoldenrod",
            "DarkMagenta",
            "DarkOliveGreen",
            "DarkRed",
            "DarkSlateBlue",
            "DeepPink",
            "IndianRed",
            "MediumSlateBlue",
            "Maroon",
            "MidnightBlue",
            "Peru",
            "SaddleBrown",
            "SteelBlue",
            "OrangeRed",
            "Firebrick",
            "DarkKhaki"
        };

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - MainWindow()

        /// <summary>
        /// 
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            List<Recipe> sourceRecipeList = GetRecipeList();

            this.filteredRecipeList.InitializeCollection(sourceRecipeList);

            this.sourceRecipeList = sourceRecipeList;

            this.itemsRepeater.ItemsSource = filteredRecipeList;

            this.filterTextBox.TextChanged         += filterTextBox_TextChanged;
            this.enableAnimationCheckBox.Checked   += enableAnimationCheckBox_Checked;
            this.enableAnimationCheckBox.Unchecked += enableAnimationCheckBox_Checked;
            this.sortAscendingButton.Click         += sortAscendingButton_Click;
            this.sortDescendingButton.Click        += sortDescendingButton_Click;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region Filter by ingredient ؽƮ ڽ ؽƮ  óϱ - filterTextBox_TextChanged(sender, e)

        /// <summary>
        /// Filter by ingredient ؽƮ ڽ ؽƮ  óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void filterTextBox_TextChanged(object sender, RoutedEventArgs e)
        {
            UpdateData();
        }

        #endregion
        #region Enable animations üũ ڽ üũ óϱ - enableAnimationCheckBox_Checked(sender, e)

        /// <summary>
        /// Enable animations üũ ڽ üũ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void enableAnimationCheckBox_Checked(object sender, RoutedEventArgs e)
        {
#if WINUI_PRERELEASE
            this.itemsRepeater.Animator = this.enableAnimationCheckBox.IsChecked.GetValueOrDefault() ? new DefaultElementAnimator() : null;
#endif
        }

        #endregion
        #region Least to most ư Ŭ óϱ - sortAscendingButton_Click(sender, e)

        /// <summary>
        /// Least to most ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void sortAscendingButton_Click(object sender, RoutedEventArgs e)
        {
            if(this.isSortDescending == true)
            {
                this.isSortDescending = false;

                UpdateData();
            }
        }

        #endregion
        #region Most to least ư Ŭ óϱ - sortDescendingButton_Click(sender, e)

        /// <summary>
        /// Most to least ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void sortDescendingButton_Click(object sender, RoutedEventArgs e)
        {
            if(!this.isSortDescending == true)
            {
                this.isSortDescending = true;

                UpdateData();
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region  ÷ ϱ - GetFruitCollection()

        /// <summary>
        ///  ÷ ϱ
        /// </summary>
        /// <returns> ÷</returns>
        private ObservableCollection<string> GetFruitCollection()
        {
            return new ObservableCollection<string>
            {
                "Apricots",
                "Bananas",
                "Grapes",
                "Strawberries",
                "Watermelon",
                "Plums",
                "Blueberries"
            };
        }

        #endregion
        #region ä ÷ ϱ - GetVegetableCollection()

        /// <summary>
        /// ä ÷ ϱ
        /// </summary>
        /// <returns>ä ÷</returns>
        private ObservableCollection<string> GetVegetableCollection()
        {
            return new ObservableCollection<string>
            {
                "Broccoli",
                "Spinach",
                "Sweet potato",
                "Cauliflower",
                "Onion",
                "Brussels sprouts",
                "Carrots"
            };
        }

        #endregion
        #region  ÷ ϱ - GetGrainCollection()

        /// <summary>
        ///  ÷ ϱ
        /// </summary>
        /// <returns> ÷</returns>
        private ObservableCollection<string> GetGrainCollection()
        {
            return new ObservableCollection<string>
            {
                "Rice",
                "Quinoa",
                "Pasta",
                "Bread",
                "Farro",
                "Oats",
                "Barley"
            };
        }

        #endregion
        #region ܹ ÷ ϱ - GetProteinCollection()

        /// <summary>
        /// ܹ ÷ ϱ
        /// </summary>
        /// <returns>ܹ ÷</returns>
        private ObservableCollection<string> GetProteinCollection()
        {
            return new ObservableCollection<string>
            {
                "Steak",
                "Chicken",
                "Tofu",
                "Salmon",
                "Pork",
                "Chickpeas",
                "Eggs"
            };
        }

        #endregion
        #region  Ʈ ϱ - GetRecipeList()

        /// <summary>
        ///  Ʈ ϱ
        /// </summary>
        /// <returns> Ʈ</returns>
        private List<Recipe> GetRecipeList()
        {
            Random random = new Random();

            List<Recipe> recipeList = new List<Recipe>
            (
                Enumerable.Range(0, 1000).Select
                (
                    k => new Recipe
                    {
                        Number = k,
                        Name = "Recipe " + k.ToString(),
                        Color = this.colorList[random.Next(0, 19)]
                    }
                )
            );

            foreach(Recipe recipe in recipeList)
            {
                string fruitOption     = GetFruitCollection()[random.Next(0, 6)];
                string vegetableOption = GetVegetableCollection()[random.Next(0, 6)];
                string grainOption     = GetGrainCollection()[random.Next(0, 6)];
                string proteinOption   = GetProteinCollection()[random.Next(0, 6)];

                recipe.Ingredients   = "\n" + fruitOption + "\n" + vegetableOption + "\n" + grainOption + "\n" + proteinOption;
                recipe.IngrdientList = new List<string>() { fruitOption, vegetableOption, grainOption, proteinOption };

                recipe.RandomizeIngredients();
            }

            return recipeList;
        }

        #endregion
        #region  Ʈϱ - UpdateData()

        /// <summary>
        ///  Ʈϱ
        /// </summary>
        private void UpdateData()
        {
            var filteredRecipeEnumerable = sourceRecipeList.Where
            (
                i => i.Ingredients.Contains(this.filterTextBox.Text, StringComparison.InvariantCultureIgnoreCase)
            );

            var sortedRecipeEnumerable = this.isSortDescending ?
                filteredRecipeEnumerable.OrderByDescending(i => i.IngrdientList.Count()) :
                filteredRecipeEnumerable.OrderBy(i => i.IngrdientList.Count());

            this.filteredRecipeList.InitializeCollection(sortedRecipeEnumerable);
        }

        #endregion
    }
}