﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.Specialized;

using Microsoft.UI.Xaml.Controls;

namespace TestProject
{
    /// <summary>
    /// 레시피 리스트
    /// </summary>
    public class RecipeList : IList, IKeyIndexMapping, INotifyCollectionChanged
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Event
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 컬렉션 변경시 - CollectionChanged

        /// <summary>
        /// 컬렉션 변경시
        /// </summary>
        public event NotifyCollectionChangedEventHandler CollectionChanged;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 내부 리스트
        /// </summary>
        private List<Recipe> innerList = new List<Recipe>();

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region (IList) 카운트 - Count

        /// <summary>
        /// 카운트
        /// </summary>
        public int Count => this.innerList != null ? this.innerList.Count : 0;

        #endregion
        #region (IList) 인덱서 - this[index]

        /// <summary>
        /// 인덱서
        /// </summary>
        /// <param name="index">인덱스</param>
        /// <returns>레시피</returns>
        public object this[int index]
        {
            get
            {
                return this.innerList[index] as Recipe;
            }

            set
            {
                this.innerList[index] = (Recipe)value;
            }
        }

        #endregion

        #region (IList) 고정 크기 여부 - IsFixedSize

        /// <summary>
        /// 고정 크기 여부
        /// </summary>
        public bool IsFixedSize => throw new NotImplementedException();

        #endregion
        #region (IList) 읽기 전용 여부 - IsReadOnly

        /// <summary>
        /// 읽기 전용 여부
        /// </summary>
        public bool IsReadOnly => throw new NotImplementedException();

        #endregion
        #region (IList) 동기화 여부 - IsSynchronized

        /// <summary>
        /// 동기화 여부
        /// </summary>
        public bool IsSynchronized => throw new NotImplementedException();

        #endregion
        #region (IList) 동기 루트 - SyncRoot

        /// <summary>
        /// 동기 루트
        /// </summary>
        public object SyncRoot => throw new NotImplementedException();

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - RecipeList(recipeEnumerable)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="recipeEnumerable">레시피 열거 가능형</param>
        public RecipeList(IEnumerable<Recipe> recipeEnumerable)
        {
            InitializeCollection(recipeEnumerable);
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 컬렉션 초기화하기 - InitializeCollection(recipeEnumerable)

        /// <summary>
        /// 컬렉션 초기화하기
        /// </summary>
        /// <param name="recipeEnumerable">레시피 열거 가능형</param>
        public void InitializeCollection(IEnumerable<Recipe> recipeEnumerable)
        {
            this.innerList.Clear();

            if(recipeEnumerable != null)
            {
                this.innerList.AddRange(recipeEnumerable);
            }

            CollectionChanged?.Invoke(this, new NotifyCollectionChangedEventArgs(NotifyCollectionChangedAction.Reset));
        }

        #endregion

        #region (IList) 열거자 구하기 - GetEnumerator()

        /// <summary>
        /// 열거자 구하기
        /// </summary>
        /// <returns>열거자</returns>
        public IEnumerator<Recipe> GetEnumerator() => this.innerList.GetEnumerator();

        #endregion
        #region (IList) 열거자 구하기 - IEnumerable.GetEnumerator()

        /// <summary>
        /// 열거자 구하기
        /// </summary>
        /// <returns>열거자</returns>
        IEnumerator IEnumerable.GetEnumerator()
        {
            throw new NotImplementedException();
        }

        #endregion
        #region (IList) 추가하기 - Add(value)

        /// <summary>
        /// 추가하기
        /// </summary>
        /// <param name="value">값</param>
        /// <returns>인덱스</returns>
        public int Add(object value)
        {
            throw new NotImplementedException();
        }

        #endregion
        #region (IList) 지우기 - Clear()

        /// <summary>
        /// 지우기
        /// </summary>
        public void Clear()
        {
            throw new NotImplementedException();
        }

        #endregion
        #region (IList) 포함 여부 구하기 - Contains(value)

        /// <summary>
        /// 포함 여부 구하기
        /// </summary>
        /// <param name="value">값</param>
        /// <returns>포함 여부</returns>
        public bool Contains(object value)
        {
            throw new NotImplementedException();
        }

        #endregion
        #region (IList) 인덱스 구하기 - IndexOf(value)

        /// <summary>
        /// 인덱스 구하기
        /// </summary>
        /// <param name="value">값</param>
        /// <returns>인덱스</returns>
        public int IndexOf(object value)
        {
            throw new NotImplementedException();
        }

        #endregion
        #region (IList) 삽입하기 - Insert(index, value)

        /// <summary>
        /// 삽입하기
        /// </summary>
        /// <param name="index">인덱스</param>
        /// <param name="value">값</param>
        public void Insert(int index, object value)
        {
            throw new NotImplementedException();
        }

        #endregion
        #region (IList) 제거하기 - Remove(value)

        /// <summary>
        /// 제거하기
        /// </summary>
        /// <param name="value">값</param>
        public void Remove(object value)
        {
            throw new NotImplementedException();
        }

        #endregion
        #region (IList) 제거하기 - RemoveAt(index)

        /// <summary>
        /// 제거하기
        /// </summary>
        /// <param name="index">인덱스</param>
        public void RemoveAt(int index)
        {
            throw new NotImplementedException();
        }

        #endregion
        #region (IList) 복사하기 - CopyTo(array, index)

        /// <summary>
        /// 복사하기
        /// </summary>
        /// <param name="array">배열</param>
        /// <param name="index">인덱스</param>
        public void CopyTo(Array array, int index)
        {
            throw new NotImplementedException();
        }

        #endregion

        #region (IKeyIndexMapping) 인덱스에서 키 구하기 - KeyFromIndex(index)

        /// <summary>
        /// 인덱스에서 키 구하기
        /// </summary>
        /// <param name="index">인덱스</param>
        /// <returns>키</returns>
        public string KeyFromIndex(int index)
        {
            return this.innerList[index].Number.ToString();
        }

        #endregion
        #region (IKeyIndexMapping) 키에서 인덱스 구하기 - IndexFromKey(key)

        /// <summary>
        /// 키에서 인덱스 구하기
        /// </summary>
        /// <param name="key">키</param>
        /// <returns>인덱스</returns>
        public int IndexFromKey(string key)
        {
           foreach(Recipe recipe in this.innerList)
           {
                if(recipe.Number.ToString() == key)
                {
                    return this.innerList.IndexOf(recipe);
                }
           }

           return -1;
        }

        #endregion
    }
}